db.getMongo().setReadPref('secondary');

var arr = []
db.getCollection('user_variables').find({
	platform:'facebook', 
    platformBotId:'179841912424835', 
    name: 'CommentServicesLog', 
    lastUpdatedDate: {$gt: ISODate("2021-07-07T00:00-0700"), $lt: ISODate("2021-07-08T00:00-0700")}
}).forEach((doc) => {
    doc.value.forEach((entry) => {
        if(new Date(entry.timestamp) > ISODate("2021-07-07T00:00-0700") && new Date(entry.timestamp) < ISODate("2021-07-08T00:00-0700") 
            && (entry.reasonForAction !== "No tag" || true)) {
            entry.timestamp = new Date(entry.timestamp).toUTCString()
            if(!entry.URL && entry.platform=="facebook") {
            	entry.URL = "https://www.facebook.com/179841912424835/posts/" + entry.postId.split('_')[1] +
              '?comment_id=' + entry.commentId.split('_')[1]
              }
            arr.push(entry)
        }
    })
})

print(JSON.stringify(arr));
