const fs = require("fs"),
    request = require("request-promise-native");
const AMPLIFY_API_BASE_URL = "https://api.amplify.ai/api/v1",
    GSHEETS_CONNECTOR_BASE_URL = "https://23pysf2rdf.execute-api.us-east-1.amazonaws.com/prod";
async function init() {
    const auth = await getAmplifyAuthToken("jake+readonlyadmin@amplify.ai", "xixujebofacu");
    const bots = JSON.parse(fs.readFileSync("./bots.json").toString());
    if (auth && auth.access_token) {
       const authToken = auth.access_token;
       const readTwilioSidData = (JSON.parse((await  readTwilioSid("1yPTeDwVSWRsgAeev8auL1W0yQxAUg9mjjk8Ohy3IUDk", "Toll Free Verification")).toString())).data;
      const TFNSheetData=[],TFNSheetData_businessName=[],TFNSheetData_Sid_TFN=[],TFNSheetData_popUrl=[];
         var flag=false;
         //for existing accounts in sheet
        for( tsid in readTwilioSidData){
        	for (botIndex in bots) {
                        flag=false;
                    const bot = bots[botIndex];
                    if(readTwilioSidData[tsid] == bot.accountSID){
                    	flag=true;
                    	var tfn_Number;
                    	if(bot.accountSID && bot.twilioAuthToken){
                            try{
                              const phoneNumbers = JSON.parse(await getPhoneNumbers(bot.platformBotId, bot.accountSID, bot.twilioAuthToken));
                              const businessName = (JSON.parse(await getBusinessName(bot.accountSID, bot.twilioAuthToken))).friendly_name;
                              if(phoneNumbers.phone_numbers && phoneNumbers.phone_numbers.length) {
                                  for(entry of phoneNumbers.phone_numbers) {
                                         tfn_Number = entry.phone_number;
                                  }
                              }
                              var url;
                              const botPopUrl = (JSON.parse(await getBotUrl(authToken, bot.botId))) ;
                              if(botPopUrl.config && botPopUrl.config.profile && botPopUrl.config.profile.popupUrl){
                              	url=botPopUrl.config.profile.popupUrl;
                              } else url='NA'
                              TFNSheetData.push([bot.accountSID,tfn_Number,businessName,url]);
                              TFNSheetData_businessName.push([businessName]);
                              TFNSheetData_Sid_TFN.push([bot.accountSID,tfn_Number]);
                              TFNSheetData_popUrl.push([url]);
                              break;
                            }
                            catch (err) {
                                console.log("Error", err.message);
                            }
                        }
                	}
            	}
                //for archieved or deleted accounts........ 
                if(flag==false)
                {
                			 TFNSheetData.push([readTwilioSidData[tsid][0],'NA','NA','NA']);
                              TFNSheetData_businessName.push(['NA']);
                              TFNSheetData_Sid_TFN.push([readTwilioSidData[tsid][0],'NA']);
                              TFNSheetData_popUrl.push(['NA']);
                }
        	}
        //for new data
        for (botIndex in bots) {
        	var flag=false;
        	const bot = bots[botIndex];
            for( tsid in readTwilioSidData){	
                    if(readTwilioSidData[tsid] == bot.accountSID){
                    	flag=true;
                        break;
                    }
            }
             if(flag==false){
                     var tfn_Number;
                    if(bot.accountSID && bot.twilioAuthToken){
                        try{
                          const phoneNumbers = JSON.parse(await getPhoneNumbers(bot.platformBotId, bot.accountSID, bot.twilioAuthToken));
                          const businessName = (JSON.parse(await getBusinessName(bot.accountSID, bot.twilioAuthToken))).friendly_name;
                          if(phoneNumbers.phone_numbers && phoneNumbers.phone_numbers.length) {
                              for(entry of phoneNumbers.phone_numbers) {
                                     tfn_Number = entry.phone_number;
                              }
                          }
                          var url;
                          const botPopUrl = (JSON.parse(await getBotUrl(authToken, bot.botId))) ;
                          if(botPopUrl.config && botPopUrl.config.profile && botPopUrl.config.profile.popupUrl){
                          url=botPopUrl.config.profile.popupUrl;
                          } else url='NA'
                          TFNSheetData.push([bot.accountSID,tfn_Number,businessName,url]);
                          TFNSheetData_businessName.push([businessName]);
                          TFNSheetData_Sid_TFN.push([bot.accountSID,tfn_Number]);
                          TFNSheetData_popUrl.push([url]);
                        }
                        catch (err) {
                            console.log("Error", err.message);
                        }
                    }
                }
            }
        
        console.log("Sheet Data", TFNSheetData);
        //const gSheetConnectorResponseTFNData = await writeToSheet("1yPTeDwVSWRsgAeev8auL1W0yQxAUg9mjjk8Ohy3IUDk", "Toll Free Verification", TFNSheetData);
        const gSheetConnectorResponseTFN_businessName_Data = await writeToSheet_businessName("1yPTeDwVSWRsgAeev8auL1W0yQxAUg9mjjk8Ohy3IUDk", "Toll Free Verification", TFNSheetData_businessName);
        const gSheetConnectorResponseTFN_Sid_TFN_Data = await writeToSheet_sid("1yPTeDwVSWRsgAeev8auL1W0yQxAUg9mjjk8Ohy3IUDk", "Toll Free Verification", TFNSheetData_Sid_TFN);
        const gSheetConnectorResponseTFN_url_Data = await writeToSheet_url("1yPTeDwVSWRsgAeev8auL1W0yQxAUg9mjjk8Ohy3IUDk", "Toll Free Verification", TFNSheetData_popUrl);
        //console.log("GSheet Write Response for TFN data:", gSheetConnectorResponseTFNData);
        console.log("GSheet Write Response for TFN data:", gSheetConnectorResponseTFN_businessName_Data);
        console.log("GSheet Write Response for TFN data:", gSheetConnectorResponseTFN_Sid_TFN_Data);
        console.log("GSheet Write Response for TFN data:", gSheetConnectorResponseTFN_url_Data);
    }
}
async function getPhoneSid(twilioSubAccountSID, twilioAuthToken) {
      const options = {
          url: `https://messaging.twilio.com/v1/Accounts/${twilioSubAccountSID}/Calls.json`,
          auth: {
              user: twilioSubAccountSID,
              password: twilioAuthToken
          }
      }
      return request.get(options);
}

async function getPhoneNumbers(twilioMessagingSID, twilioSubAccountSID, twilioAuthToken) {
      const options = {
          url: `https://messaging.twilio.com/v1/Services/${twilioMessagingSID}/PhoneNumbers?PageSize=1000`,
          auth: {
              user: twilioSubAccountSID,
              password: twilioAuthToken
          }
      }
      return request.get(options);
}
async function getBusinessName(twilioSubAccountSID, twilioAuthToken) {
      const options = {
          url: `https://api.twilio.com/2010-04-01/Accounts/${twilioSubAccountSID}.json`,
          auth: {
              user: twilioSubAccountSID,
              password: twilioAuthToken
          }
      }
      return request.get(options);
}

async function getAmplifyAuthToken(username, password) {
    const options = {
        url: `${AMPLIFY_API_BASE_URL}/login`,
        headers: {
            Accept: "application/json",
            "Content-Type": "application/json"
        },
        json: {
            username,
            password
        }
    };
    return await request.post(options);
}
async function getBotUrl(authToken, botId) {
    const options = {
        url: `${AMPLIFY_API_BASE_URL}/bots/${botId}`,
        headers: {
            Accept: "application/json",
            "Content-Type": "application/json",
            "x-access-token": authToken
        }
    };
    return await request.get(options);
}
async function writeToSheet_businessName(spreadsheetId, sheetName, data) {
    const options = {
        url: `${GSHEETS_CONNECTOR_BASE_URL}/gsheet/${spreadsheetId}`,
        headers: {
            Accept: "application/json",
            "Content-Type": "application/json",
            Authorization: "Bearer R1NoZWV0Q29ubmVjdG9yOlNlcnZpY2VVc2Vy"
        },
        json: {
            sheet: sheetName,
            data: data,
            rowOffset: 1,
            clearValues: true,
            clearRowOffset: 1,
            clearColLimit: 1
        }
    };
    return await request.post(options);
}
async function writeToSheet_sid(spreadsheetId, sheetName, data) {
    const options = {
        url: `${GSHEETS_CONNECTOR_BASE_URL}/gsheet/${spreadsheetId}`,
        headers: {
            Accept: "application/json",
            "Content-Type": "application/json",
            Authorization: "Bearer R1NoZWV0Q29ubmVjdG9yOlNlcnZpY2VVc2Vy"
        },
        json: {
            sheet: sheetName,
            data: data,
            rowOffset: 1,
            colOffset:3,
            clearValues: true,
            clearRowOffset: 1,
            clearColOffset: 3,
            clearColLimit: 2
        }
    };
    return await request.post(options);
}
async function writeToSheet_url(spreadsheetId, sheetName, data) {
    const options = {
        url: `${GSHEETS_CONNECTOR_BASE_URL}/gsheet/${spreadsheetId}`,
        headers: {
            Accept: "application/json",
            "Content-Type": "application/json",
            Authorization: "Bearer R1NoZWV0Q29ubmVjdG9yOlNlcnZpY2VVc2Vy"
        },
        json: {
            sheet: sheetName,
            data: data,
            rowOffset: 1,
            colOffset: 15 ,
            clearValues: true,
            clearRowOffset: 1,
            clearColOffset: 15,
            clearColLimit: 1
        }
    };
    return await request.post(options);
}
async function writeToSheet(spreadsheetId, sheetName, data) {
    const options = {
        url: `${GSHEETS_CONNECTOR_BASE_URL}/gsheet/${spreadsheetId}`,
        headers: {
            Accept: "application/json",
            "Content-Type": "application/json",
            Authorization: "Bearer R1NoZWV0Q29ubmVjdG9yOlNlcnZpY2VVc2Vy"
        },
        json: {
            sheet: sheetName,
            data: data,
            rowOffset: 1,
            colOffset:1,
            clearValues: true,
            clearRowOffset: 1,
            clearColOffset: 1,
            clearColLimit: 3
        }
    };
    return await request.post(options);
}
async function readTwilioSid(spreadsheetId, sheetName) {
    const options = {
    	method: 'GET',
        url: `${GSHEETS_CONNECTOR_BASE_URL}/gsheet/${spreadsheetId}?sheet=${sheetName}&rowOffset=1&colOffset=3&colLimit=1`,
        headers: {
            Accept: "application/json",
            "Content-Type": "application/json",
            Authorization: "Bearer R1NoZWV0Q29ubmVjdG9yOlNlcnZpY2VVc2Vy"
        }
    };
    return await request(options);
}
function arrToObject (arr){
	var keys = ['accountName','accountId','botId', 'name'];
	//var newArr = arr.slice(1, arr.length);
	var formatted = [],
    data = arr,
    cols = keys,
    l = cols.length;
	for (var i=0; i<data.length; i++) {
			var d = data[i],
					o = {};
			for (var j=0; j<l; j++)
					o[cols[j]] = d[j];
			formatted.push(o);
	}
	return formatted;
}
function getDateInTimzeone(date, timeZone = "UTC") {
    const d = new Date(date);
    return new Date(
        d.toLocaleString("en-US", {
            timeZone
        })
    );
}
function getDateMinusNumberOfDays(date, numberOfDays) {
    const d = new Date(date);
    d.setDate(d.getDate() - numberOfDays);
    return d;
}
function getFirstDayOfMonth(date) {
    const d = new Date(date);
    return new Date(d.getFullYear(), d.getMonth(), 1);
}
function formatDate(date) {
    var d = new Date(date),
        month = "" + (d.getMonth() + 1),
        day = "" + d.getDate(),
        year = d.getFullYear();
    if (month.length < 2) month = "0" + month;
    if (day.length < 2) day = "0" + day;
    return [year, month, day].join("-");
}
function simplifyDate(date) {
    return date.split("-").join("");
}
init();
