const fs = require('fs');

const filePath = process.argv[2]

const records = JSON.parse(fs.readFileSync(filePath).toString())

let totalDollars = 0;
let totalContributions = 0;

for(donation of records) {
    totalDollars += parseInt(donation.Total, 10);
    totalContributions += parseInt(donation.Count, 10);
}

console.log(`$${totalDollars} raised over ${totalContributions} donations`)
