db.getMongo().setReadPref("secondary");

const count = {};

// prettier-ignore
db.getCollection('user_variables').find({platform: "twilio_sms", platformBotId: "MG16ad4e8f80c333963c92fb3e04c47360", name: "referrerAffiliateId", value: { $ne: "" }, lastUpdatedDate: { $gt: ISODate("2022-12-01T00:00-0800"), $lt: ISODate("2024-06-28T00:00-0700")}}).forEach((doc) => {
    if(!count[doc.value]) {
        count[doc.value] = 0;
    }
    count[doc.value]++;
});

printjson(count);

// prettier-ignore
const sheetData = Object.keys(count).map((affId) => {
    return [affId, count[affId]];
}).sort((a, b) => {
    return a[1] < b[1];
});

writeFile("./sheetData.json", JSON.stringify(sheetData));
